<?php
/*
Plugin Name: WP Quote Tweets
Version: 3.0.0
Plugin URI:  http://0xtc.com/2009/06/18/wordpress-plugin-wp-quote-tweets.xhtml
Description: Allows authors to quote Twitter updates in posts or pages using a simple shortcode. [quotetweet tweetid=123456789].
Contributors: 0xtc
Author: Tanin Ehrami
Author URI: http://0xtc.com/
Stable tag: trunk
*/

/* 						// debugging
ini_set("display_errors","2");
ERROR_REPORTING(E_ALL);
*/
if (!class_exists("wpQuoteTweet")) {
	class wpQuoteTweet {
		var $OptionsNamePre = "wpQuoteTweetAdminOptions";
		var $prefs = NULL;
		function wpQuoteTweet() {
			$this->prefs = $this->getAdminOptions();
			add_shortcode ('quotetweet', array(&$this, 'wp_quote_tweet_exec'));
		}

		function init() {
			$this->prefs = $this->getAdminOptions();
		}

		function getAdminOptions() {
			$wpQuoteTwAdminOptions = array('template' => 'twitter','TweetKeepCache'=>'infinite');
			$qtwOptions = get_option($this->OptionsNamePre);
			if (!empty($qtwOptions)) {
				foreach ($qtwOptions as $key => $option)
					$wpQuoteTwAdminOptions[$key] = $option;
			}				
			update_option($this->OptionsNamePre, $wpQuoteTwAdminOptions);
			return $wpQuoteTwAdminOptions;
		}

		function wp_quote_tweet_add_header() {
			$qtwOptions = $this->prefs;
			$templatesDir = 'templates/';
			$templatePref = $qtwOptions['template'];
			$templateFile = '/'.$templatePref.'.css';
			$templatefilepath = $templatesDir.$templatePref.$templateFile;
			$pluginPath = get_bloginfo('wpurl').'/wp-content/plugins/wp-quote-tweets/';
			$cssline = "\r\n\t<!-- WP Quote Tweets 3.0.0 -->\r\n\t<link rel=\"stylesheet\" href=\"".$pluginPath.$templatefilepath."\" type=\"text/css\" media=\"screen\" />\n";
			echo $cssline;
		}

		function printAdminPage() {
			$qtwOptions = $this->prefs;
			
			if (isset($_POST['update_wpQuoteTweetSettings'])) {
				if (isset($_POST['wpQuoteTwTemplate'])) {
					$qtwOptions['template'] = $_POST['wpQuoteTwTemplate'];
				}
				update_option($this->OptionsNamePre, $qtwOptions);
				?>
					<div class="updated"><p><strong><?php _e("Settings Updated.", "wpQuoteTweet");?></strong></p></div>
				<?php
			}
			
			if (isset($_POST['wpQuoteTweetClearCache'])) {
				if ($_POST['wpQuoteTweetClearCache']=='please') {
						$mydir = dirname(__FILE__).'/cache/'; 
						$d = dir($mydir); 
						while($entry = $d->read()) { 
							if ($entry!= "." && $entry != "..") { 
								unlink(dirname(__FILE__).'/cache/'.$entry);
							}
						}
						$d->close();
				}
				?>
					<div class="updated"><p><strong><?php _e("Cache cleared.", "wpQuoteTweet");?></strong></p></div>
				<?php
			}
			
			if (isset($_POST['wpQuoteTweetKeepCache'])) {
				if (isset($_POST['wpQuoteTweetKeepCache'])) {
					$qtwOptions['TweetKeepCache'] = $_POST['wpQuoteTweetKeepCache'];
				}
				update_option($this->OptionsNamePre, $qtwOptions);
				?>
					<div class="updated"><p><strong><?php _e("Cache settings updated.", "wpQuoteTweet");?></strong></p></div>
				<?php
			}
			
			
			echo '
			<div class="wrap">
				<div id="icon-options-general" class="icon32"><br /></div> 
				<h2>WP Quote Tweets</h2>
				<div id="poststuff" class="metabox-holder has-right-sidebar">
					<div id="post-body"> 
						<div id="post-body-content">';
							$dirPath = dirname(__FILE__).'/templates/';
							echo '
							<div id="templateselect" class="stuffbox">
								<h3 class="hndle">Settings</h3>
								<div class="inside">
									<h2>Cache settings</h2>
									<form method="post" action="'. $_SERVER["REQUEST_URI"].'">
										<p>
											<label for="wpQuoteTweetKeepCache">
												Keep Tweets in cache for 
											</label>
											<select name="wpQuoteTweetKeepCache" id="wpQuoteTweetKeepCache" name="wpQuoteTweetKeepCache">';
												if ($file == $qtwOptions['template']){
													$selected=' checked="checked"';
												} else {
													$selected='';
												}
												echo '												
												<option '.($qtwOptions['TweetKeepCache']=='86400'?'selected="selected"':'').' value="86400">24 hours</option>
												<option '.($qtwOptions['TweetKeepCache']=='172800'?'selected="selected"':'').' value="172800">2 days</option>
												<option '.($qtwOptions['TweetKeepCache']=='345600'?'selected="selected"':'').' value="345600">4 days</option>
												<option '.($qtwOptions['TweetKeepCache']=='604800'?'selected="selected"':'').' value="604800">1 week</option>
												<option '.($qtwOptions['TweetKeepCache']=='1209600'?'selected="selected"':'').' value="1209600">2 weeks</option>
												<option '.($qtwOptions['TweetKeepCache']=='infinite'?'selected="selected"':'').' value="infinite">Forever</option>
											</select>
										</p>
								
								
										<h2>Select a template</h2>';
									if ($handle = opendir($dirPath)) {
										while (false !== ($file = readdir($handle))) {
											if ($file != "." && $file != "..") {
												if (file_exists("$dirPath/$file/$file.template.html")) {
													if ($file == $qtwOptions['template']){
														$selected=' checked="checked"';
													} else {
														$selected='';
													}
													echo '
										<div style="border-bottom:1px solid #ddd;border-top:1px solid #fff;">
											<h4>'.$file.'</h4>
											<input type="radio"'.$selected.' value="'.$file.'" name="wpQuoteTwTemplate" /> 
											<img style="vertical-align:middle" src="'.WP_PLUGIN_URL.'/wp-quote-tweets/templates/'.$file.'/'.$file.'.png" />
											<br />
											<p style="width:600px">';
												if (file_exists("$dirPath/$file/readme.txt")){
													echo file_get_contents("$dirPath/$file/readme.txt");
												}
												echo '<br />
											</p>
										</div>	
										';
												}
											}
										}
								   closedir($handle);
									}
										echo '
										<div class="submit" style="float:right;">
												<input type="submit" name="update_wpQuoteTweetSettings" value="';
												_e('Update Settings', 'wpQuoteTweet');
												echo '" />
										</div>
										<br class="clear" />
										<p>Want to create your own? Read the <a href="http://0xtc.com/2009/07/09/creating-a-wp-quote-tweets-template.xhtml" title="Make your own templates!" target="_blank">documentation</a>.</p>
										<input type="hidden" name="wpQuoteTweetClearCache" value="please" />
									</form>
								</div>
							</div>
						</div>
					</div>

					<div id="side-info-column" class="inner-sidebar"> 
						<div id="side-sortables" class="meta-box-sortables"> 
							<div id="wpqthelpdiv" class="postbox " > 
								<h3 class="hndle"><span>Just so you know....</span></h3> 
								<div class="inside"> 
									<h4>Caching</h4>
									<p>
										This plugin caches the information it gets from Twitter.com so your server plays nice and doesn\'t make too many requests. But you should keep in mind 
										that the cache is deleted every time you update settings here. Every time you select a new template, the plugin will rebuild the quotes (again) by making 
										requests to twitter.com.
									</p>
								</div>
							</div>
						</div>
					</div>					
				</div>
			</div>';
		}

		function wp_quote_tweet_exec($att,$content=null){
			extract	(shortcode_atts(array('tweetid'=>'0'), $att));
			if ($tweetid==0){return false;}
			$TwitterCacheDir = dirname(__FILE__).'/cache/';
			$filename = $TwitterCacheDir . 'twitter.'.$tweetid.'.cache';
			$filenameFeed = $TwitterCacheDir . 'twitter.'.$tweetid.'RSS.cache';
			$cacheAge = $this->prefs['TweetKeepCache'];
			if (file_exists($filename) && !is_feed()) {
				$filedate = filemtime($filename);
				$FileAge = time() - $filedate;
				if (is_numeric($cacheAge)){
					if ($FileAge < $cacheAge){
						return file_get_contents($filename);
					}
				} else {
					return file_get_contents($filename);
				}
			}
			
			if (file_exists($filenameFeed) && is_feed()) {
				$filedate = filemtime($filenameFeed);
				$FileAge = time() - $filedate;
				if (is_numeric($cacheAge)){
					if ($FileAge < $cacheAge){
						return file_get_contents($filenameFeed);
					}
				} else {
					return file_get_contents($filenameFeed);
				}
			}
			
			$templatesDir = dirname(__FILE__).'/templates/';
			$templatePref = $this->prefs['template'];
			$templateFile = $templatePref.'.template.html';
			$templatefilepath = $templatesDir.$templatePref.'/'.$templateFile;
			if (is_feed()){
				$templatefilepath = $templatesDir.'/feed/feed.template.html';
			}
			if (file_exists($templatefilepath)) {
				$QuoteTemplate = file_get_contents($templatefilepath);
			} else {
				die ('Could not find the following template file : '.$templatefilepath);
			}

			$status = $this->wp_quote_tweet_getTwitterStatus($tweetid, true);
			
			
			if (($status==false) || $status->user->id==''){return '<code class="error">(coudn\'t load tweet '.$tweetid.')<!-- something went wrong with tweet '.$tweetid.'. Check if it still exists --></code>';}

			$is_first = true;
			$r_content = '';
			if ($status->in_reply_to_user_id <> ''){
				// thanks twitter.
				$userinfo = $this->wp_quote_tweet_getTwitterUser($status->in_reply_to_user_id);
				if ($status->in_reply_to_status_id <> ''){
					$replyToStr = ' in reply to <a href="http://twitter.com/'.$userinfo->screen_name.'/status/'.$status->in_reply_to_status_id.'" rel="external">'.$userinfo->name.'</a>';
				} else {
					$replyToStr = ' in reply to '.$userinfo->name;
				}
			} else {
				$replyToStr = '';
			}
			
			if ($status->user->profile_background_tile == 'true'){
				$tweetbgCSSprop = 'repeat-x';
			} else {
				$tweetbgCSSprop = 'no-repeat';
			}
			$findArr = Array(
				'%TWEET_URL%',
				'%REPLY_TO_LINK%',
				'%RETWEET_LINK%',
				'%USER_PICTURE_LINK%',
				'%PROFILE_LINK%',
				'%TIMESTAMP_LINK%',
				'%IN_REPLY_TO_LINK%',
				'%CREATED_AT%',
				'%TWEET_ID%',
				'%TWEET_TEXT%',
				'%FROM_LINK%',
				'%IN_REPLY_TO_STATUS_ID%',
				'%IN_REPLY_TO_USER_ID%',
				'%IN_REPLY_TO_SCREEN_NAME%',
				'%USER_ID%',
				'%USER_NAME%',
				'%USER_SCREENNAME%',
				'%USER_LOCATION%',
				'%USER_DESCRIPTION%',
				'%USER_PROFILE_IMAGE_URL%',
				'%USER_URL%',
				'%USER_FOLLOWERS_COUNT%',
				'%USER_PROFILE_BACKGROUND_COLOR%',
				'%USER_PROFILE_TEXT_COLOR%',
				'%USER_PROFILE_LINK_COLOR%',
				'%USER_PROFILE_SIDEBAR_FILL_COLOR%',
				'%USER_PROFILE_SIDEBAR_BORDER_COLOR%',
				'%USER_FRIEND_COUNT%',
				'%USER_CREATED_AT%',
				'%USER_FAVOURITES_COUNT%',
				'%USER_UTC_OFFSET%',
				'%USER_TIME_ZONE%',
				'%USER_PROFILE_BACKGROUND_IMAGE_URL%',
				'%USER_STATUSES_COUNT%',
				'%CSS_USER_BACKGROUND%'
			);
			$replaceArr = Array(
				'http://twitter.com/'.$status->user->screen_name.'/status/'.$status->id,
				'<a href="http://twitter.com/home?status=@'.$status->user->screen_name.'%20&amp;in_reply_to_status_id='.$status->id.'&amp;in_reply_to='.$status->user->screen_name.'" title="Reply to '.$status->user->name.'" rel="external" class="reply">Reply</a>',
				'<a href="http://twitter.com/home?status=RT @'.$status->user->screen_name.'%20'.urlencode(strip_tags($this->wp_quote_tweet_formatTweetContent($status->text))).'" title="Reply to '.$status->user->name.'" rel="external" class="retweet">Retweet</a>',
				'<a href="http://twitter.com/'.$status->user->screen_name.'" title="'.$status->user->name.'" class="quoting_pic" rel="external"><img src="'.$status->user->profile_image_url.'" alt="'.$status->user->screen_name.'" /></a>',
				'<a href="http://twitter.com/'.$status->user->screen_name.'" title="Twitter page : '.$status->user->name.'" rel="external">'. $status->user->screen_name.'</a>',
				'<a href="http://twitter.com/'.$status->user->screen_name.'/status/'.$status->id.'" rel="external">'.date("j-n-Y H:i:s",strtotime(str_replace(" +0000", "", $status->created_at ))).'</a>',
				$replyToStr,
				$status->created_at,
				$status->id,
				$this->wp_quote_tweet_formatTweetContent($status->text)."\r\n",
				$status->source,
				$status->in_reply_to_status_id,
				$status->in_reply_to_user_id,
				$status->in_reply_to_screen_name,
				$status->user->id,
				$status->user->name,
				$status->user->screen_name,
				$status->user->location,
				$status->user->description,
				$status->user->profile_image_url,
				$status->user->url,
				$status->user->followers_count,
				$status->user->profile_background_color,
				$status->user->profile_text_color,
				$status->user->profile_link_color,
				$status->user->profile_sidebar_fill_color,
				$status->user->profile_sidebar_border_color,
				$status->user->friends_count,
				$status->user->created_at,
				$status->user->favourites_count,
				$status->user->utc_offset,
				$status->user->time_zone,
				$status->user->profile_background_image_url,
				$status->user->statuses_count,
				'background:#'.$status->user->profile_background_color.' url('.$status->user->profile_background_image_url.') top left '.$tweetbgCSSprop
			);
			
			$r_content = str_ireplace($findArr, $replaceArr, $QuoteTemplate);
			
			if (is_writable($TwitterCacheDir) && !is_feed()){
				file_put_contents($filename, $r_content);
			} 
			
			if (is_writable($TwitterCacheDir) && is_feed()){
				file_put_contents($filenameFeed, $r_content);
			}
				
			return $r_content;
		}

		function wp_quote_tweet_formatTweetContent ($tweet){
			$search = array('&'); 
			$replace = array('&amp;');
			$tweet = str_replace($search, $replace, $tweet);
			$tweet = preg_replace("/http:\/\/(.*?)[^ ]*/"	, 	'<a href="\\0" rel="external">\\0</a>', $tweet);
			$tweet = preg_replace("(@([a-zA-Z0-9_]+))"		,	"<a href=\"http://www.twitter.com/\\1\" rel=\"external\">\\0</a>", $tweet);
			$tweet = preg_replace('/\#(\w+)/'				, 	"<a href='http://search.twitter.com/search?q=$1' rel='external'>#$1</a>", $tweet);
			return $tweet;
		}

		function wp_quote_tweet_getTwitterStatus($tweetID,$rs=false) {
			echo '<!-- debug code : '. $httpCode.' -->';
			$url = sprintf("http://twitter.com/statuses/show/%s.xml", $tweetID);
			// $status = new SimpleXMLElement(file_get_contents($url));
			// curling instead thanks to Terence Eden http://shkspr.mobi/blog/
			$curl_handle=curl_init();
			curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
			curl_setopt($curl_handle,CURLOPT_URL,$url);
			$httpCode = curl_getinfo($curl_handle, CURLINFO_HTTP_CODE);
			$content = curl_exec($curl_handle);
			curl_close($curl_handle);
			echo '<!-- debug code : '. $httpCode.' -->';
			if ($httpCode==404) {return false;}
			try { 
				$status = new SimpleXMLElement($content);
			} catch (Exception $e) { 
				return flase; 
			} 
			
			
			if ($rs == true){return $status;}
			$tweets = array();
			$message='';
			$message			= $this->wp_quote_tweet_formatTweetContent($status->text);
			$time 				= $this->wp_quote_tweet_niceTime(strtotime(str_replace("+0000", "", $status->created_at)));
			$time 				= date("j-n-Y H:i:s",strtotime(str_replace(" +0000", "", $status->created_at )));
			$profile_image_url	= $status->user->profile_image_url;
			$StatusID			= $status->id;
			$TweetUserName		= $status->user->screen_name;
			$TweeterName		= $status->user->name;
			$tweets[] = array(
				'in_reply_to_status_id'	=>	$status->in_reply_to_status_id,
				'in_reply_to_user_id'	=>	$status->in_reply_to_user_id,
				'message' 				=> 	$message,
				'time' 					=> 	$time,
				'profile_image_url'		=>	$profile_image_url,
				'StatusID'				=>	$StatusID,
				'UserName'				=>	$TweetUserName,
				'Name'					=>	$TweeterName);
			if ($TweetUserName==''){
				return false;
			}
			return $tweets;
		}

		function wp_quote_tweet_niceTime($time) {
			$delta = time() - $time;
			if ($delta < 60) { return 'less than a minute ago.';
				} else if ($delta < 120) { return 'about a minute ago.';
				} else if ($delta < (45 * 60)) { return floor($delta / 60) . ' minutes ago.';
				} else if ($delta < (90 * 60)) { return 'about an hour ago.';
				} else if ($delta < (24 * 60 * 60)) { return 'about ' . floor($delta / 3600) . ' hours ago.';
				} else if ($delta < (48 * 60 * 60)) { return '1 day ago.';
				} else { return floor($delta / 86400) . ' days ago.';
			}
		}

		function wp_quote_tweet_getTwitterUser($userID){
			$url = sprintf('http://twitter.com/users/show.xml?user_id='.$userID);
//			$userinfo = new SimpleXMLElement(file_get_contents($url));
			// curling instead thanks to Terence Eden http://shkspr.mobi/blog/
			$curl_handle=curl_init();
			curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
			curl_setopt($curl_handle,CURLOPT_URL,$url);
			$content = curl_exec($curl_handle);
			curl_close($curl_handle);
			$userinfo = new SimpleXMLElement($content);			
			return $userinfo;
		}
	}	// class
}	//if

if (class_exists("wpQuoteTweet")) {
	$quoteTweets = new wpQuoteTweet();
}

if (!function_exists("wpQuoteTweet_ap")) {
	function wpQuoteTweet_ap() {
		global $quoteTweets;
		if (!isset($quoteTweets)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('WP Quote Tweets', 'WP Quote Tweets', 9, basename(__FILE__), array(&$quoteTweets, 'printAdminPage'));
		}
	}	
}

if (isset($quoteTweets)) {
	add_action('admin_menu', 'wpQuoteTweet_ap');
	add_action('wp_head', array(&$quoteTweets, 'wp_quote_tweet_add_header'), 1);
	add_action('activate_wp-quote-tweets/wp_quotetweets.php',  array(&$quoteTweets, 'init'));
}

?>